
//  MatoOffscreenApplet.java  (c) 2004 Kari Laitinen

//  2004-11-02  File created.
//  2009-11-12  Last modification.

//  Tama ohjelma toimii kuten MatoApplet.java, mutta tassa
//  on kaytetty ns. offscreen image -tekniikkaa ruudun valkkymisen
//  estoon.

//  Ruudulle piirtaminen tapahtuu siten etta mato piirretaan
//  kuva_johon_piirretaan -olioon, joka on Image-olio, joka sitten
//  kokonaisuutena piirretaan ruudulle.

//  Varsinkin paljon ruudulle piirtoa sisaltavissa sovellutuksissa
//  tama offscreen image -tekniikan kaytto on hyodyllista.

//  Taman tekniikan eras varjopuoli on etta tuo ulkopuolinen
//  kuva ruudusta kuluttaa runsaasti muistia.

//  Tassa esittya ruudun paivitystekniikkaa kutsutaan myos
//  tuplapuskuroinniksi (double buffering). Ruudulle tuleva kuva
//  piirretaan tassa tuplasti. Ensin piirretaan yhdesti tai useammin
//  ruudun sisaltoa esittavaan kuvaan, ja sitten piirretaan tuo
//  kuva varsinaiselle ruudulle. Nain ruudulle piirtamista tapahtuu
//  vain kerran, ja ruudun valkkyminen estyy.

import java.awt.* ;
import java.util.* ;

public class MatoOffscreenApplet extends javax.swing.JApplet
                                 implements Runnable
{
   Thread  tahdistussaie ;

   boolean  saietta_on_suoritettava  =  false ;

   Color apletin_taustavari  = new Color( 240, 240, 255 ) ; // sinertv
   Color madon_vari          = Color.RED ;

   Image  kuva_johon_piirretaan ;
   Graphics  kuvan_grafiikka ;

   int  madon_paikka_x  ;
   int  madon_paikka_y  =  150 ;

   int  madon_pituus    =  100 ;
   int  madon_korkeus   =   30 ;

   int  apletin_leveys, apletin_korkeus ;

   public void init()
   {
      apletin_leveys   =  getSize().width ;
      apletin_korkeus  =  getSize().height ;

      kuva_johon_piirretaan  =  createImage( apletin_leveys, apletin_korkeus ) ;

      kuvan_grafiikka  =  kuva_johon_piirretaan.getGraphics() ;
   }

   public void start()
   {
      if ( tahdistussaie  ==  null )
      {
         tahdistussaie  =  new  Thread( this ) ;
         saietta_on_suoritettava  =  true ;

         tahdistussaie.start() ;
      }
   }

   public void stop()
   {
      if ( tahdistussaie  !=  null )
      {
         tahdistussaie.interrupt() ;  //  keskeyt mahdollisesti nukkuva sie
         saietta_on_suoritettava  =  false ;
         tahdistussaie  =  null ;
      }
   }

   public void run()
   {
      while ( saietta_on_suoritettava  ==  true )
      {
         madon_paikka_x  =  50 ;
         madon_pituus    = 100 ;

         repaint() ;

         lepuuta_tata_saietta( 2000 ) ;

         while ( madon_paikka_x  +  madon_pituus  <  apletin_leveys  &&
                 saietta_on_suoritettava  ==  true )
         {
            for ( int venytyslaskuri  =  0 ;
                      venytyslaskuri  <  7 ;
                      venytyslaskuri  ++ )
            {
               madon_pituus  =  madon_pituus  + 5 ;

               repaint() ;
               lepuuta_tata_saietta( 50 ) ;
            }

            for ( int supistuslaskuri  =  0 ;
                      supistuslaskuri  <  7 ;
                      supistuslaskuri  ++ )
            {
               madon_pituus    =  madon_pituus    -  5 ;
               madon_paikka_x  =  madon_paikka_x  +  5 ;

               repaint() ;
               lepuuta_tata_saietta( 50 ) ;
            }
         }

         lepuuta_tata_saietta( 4000 ) ;
      }  
   }

   void  lepuuta_tata_saietta( int lepuutusaika_millisekunteina )
   {
      if ( saietta_on_suoritettava  ==  true )
      {
         try
         {
            Thread.sleep( lepuutusaika_millisekunteina ) ;
         }
         catch ( InterruptedException vangittu_poikkeus )
         {
         }
      }
   }


   public void paint( Graphics graphics )
   {
      //  super.paint( graphics ) ;

      //  kuva tyhjennetaan ja piirretaan mato siihen
      kuvan_grafiikka.setColor( apletin_taustavari ) ;
      kuvan_grafiikka.fillRect( 0, 0, apletin_leveys, apletin_korkeus ) ;

      kuvan_grafiikka.setColor( madon_vari ) ;

      kuvan_grafiikka.fillRoundRect( madon_paikka_x, madon_paikka_y,
                                     madon_pituus, madon_korkeus,
                                     20, 20  ) ;
                                     
      //  kuva piirretaan oikealle ruudulle

      graphics.drawImage( kuva_johon_piirretaan, 0, 0, this ) ;
   }
}










